Overview | Package | Class | Tree | Deprecated | Index | Help
| J2EE1.4 SDK
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.management.openmbean
Class CompositeDataSupport

    java.lang.Object
      javax.management.openmbean.CompositeDataSupport

All Implemented Interfaces:
  CompositeData, java.io.Serializable

public class CompositeDataSupport
extends java.lang.Object
implements CompositeData, java.io.Serializable

The `CompositeDataSupport` class is the open data class which implements the `CompositeData` interface.

Since:
  JMX 1.1
Version:
  3.27 04/03/24
Author:
  Sun Microsystems, Inc.
See Also:
  Serialized Form

Constructor Summary
`CompositeDataSupport(CompositeType compositeType, java.util.Map items)` Constructs a `CompositeDataSupport` instance with the specified `compositeType`, whose item names and corresponding values are given by the mappings in the map `items`.
`CompositeDataSupport(CompositeType compositeType, java.lang.String[] itemNames, java.lang.Object[] itemValues)` Constructs a `CompositeDataSupport` instance with the specified `compositeType`, whose item values are specified by `itemValues[]`, in the same order as in `itemNames[]`.

Method Summary
`boolean` | `containsKey(java.lang.String key)` Returns `true` if and only if this `CompositeData` instance contains an item whose name is `key`.
`boolean` | `containsValue(java.lang.Object value)` Returns `true` if and only if this `CompositeData` instance contains an item whose value is `value`.
`boolean` | `equals(java.lang.Object obj)` Compares the specified obj parameter with this `CompositeDataSupport` instance for equality.
`java.lang.Object` | `get(java.lang.String key)` Returns the value of the item whose name is `key`.
`java.lang.Object[]` | `getAll(java.lang.String[] keys)` Returns an array of the values of the items whose names are specified by `keys`, in the same order as `keys`.
`CompositeType` | `getCompositeType()` Returns the composite type of this composite data instance.
`int` | `hashCode()` Returns the hash code value for this `CompositeDataSupport` instance.
`java.lang.String` | `toString()` Returns a string representation of this `CompositeDataSupport` instance.
`java.util.Collection` | `values()` Returns an unmodifiable Collection view of the item values contained in this `CompositeData` instance.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### CompositeDataSupport

    public CompositeDataSupport(CompositeType compositeType,
                                java.lang.String[] itemNames,
                                java.lang.Object[] itemValues)
                         throws OpenDataException

  Constructs a `CompositeDataSupport` instance with the specified `compositeType`, whose item values are specified by `itemValues[]`, in the same order as in `itemNames[]`. As a `CompositeType` does not specify any order on its items, the `itemNames[]` parameter is used to specify the order in which the values are given in `itemValues[]`. The items contained in this `CompositeDataSupport` instance are internally stored in a `TreeMap`, thus sorted in ascending lexicographic order of their names, for faster retrieval of individual item values.

  The constructor checks that all the constraints listed below for each parameter are satisfied, and throws the appropriate exception if they are not.

Parameters:
  `compositeType` - the composite type of this composite data instance; must not be null.

  `itemNames` - `itemNames` must list, in any order, all the item names defined in `compositeType`; the order in which the names are listed, is used to match values in `itemValues[]`; must not be null or empty.

  `itemValues` - the values of the items, listed in the same order as their respective names in `itemNames`; each item value can be null, but if it is non-null it must be a valid value for the open type defined in `compositeType` for the corresponding item; must be of the same size as `itemNames`; must not be null or empty.

Throws:
  `java.lang.IllegalArgumentException` - `compositeType` is null, or `itemNames[]` or `itemValues[]` is null or empty, or one of the elements in `itemNames[]` is a null or empty string, or `itemNames[]` and `itemValues[]` are not of the same size.

  `OpenDataException` - `itemNames[]` or `itemValues[]`'s size differs from the number of items defined in `compositeType`, or one of the elements in `itemNames[]` does not exist as an item name defined in `compositeType`, or one of the elements in `itemValues[]` is not a valid value for the corresponding item as defined in `compositeType`.

### CompositeDataSupport

    public CompositeDataSupport(CompositeType compositeType,
                                java.util.Map items)
                         throws OpenDataException

  Constructs a `CompositeDataSupport` instance with the specified `compositeType`, whose item names and corresponding values are given by the mappings in the map `items`. This constructor converts the keys to a string array and the values to an object array and calls `CompositeDataSupport(javax.management.openmbean.CompositeType, java.lang.String[], java.lang.Object[])`.

Parameters:
  `compositeType` - the composite type of this composite data instance; must not be null.

  `items` - the mappings of all the item names to their values; `items` must contain all the item names defined in `compositeType`; must not be null or empty.

Throws:
  `java.lang.IllegalArgumentException` - `compositeType` is null, or `items` is null or empty, or one of the keys in `items` is a null or empty string, or one of the values in `items` is null.

  `OpenDataException` - `items`' size differs from the number of items defined in `compositeType`, or one of the keys in `items` does not exist as an item name defined in `compositeType`, or one of the values in `items` is not a valid value for the corresponding item as defined in `compositeType`.

  `java.lang.ArrayStoreException` - one or more keys in `items` is not of the class `java.lang.String`.

Method Detail

### getCompositeType

    public CompositeType getCompositeType()

  Returns the composite type of this composite data instance.

  Specified by:
    `getCompositeType` in interface `CompositeData`
  Returns:
    the type of this CompositeData.

### get

    public java.lang.Object get(java.lang.String key)

  Returns the value of the item whose name is `key`.

  Specified by:
    `get` in interface `CompositeData`
  Parameters:
    `key` - the name of the item.
  Returns:
    the value associated with this key.
  Throws:
    `java.lang.IllegalArgumentException` - if `key` is a null or empty String.
    `InvalidKeyException` - if `key` is not an existing item name for this `CompositeData` instance.

### getAll

    public java.lang.Object[] getAll(java.lang.String[] keys)

  Returns an array of the values of the items whose names are specified by `keys`, in the same order as `keys`.

  Specified by:
    `getAll` in interface `CompositeData`
  Parameters:
    `keys` - the names of the items.
  Returns:
    the values corresponding to the keys.
  Throws:
    `java.lang.IllegalArgumentException` - if an element in `keys` is a null or empty String.
    `InvalidKeyException` - if an element in `keys` is not an existing item name for this `CompositeData` instance.

### containsKey

    public boolean containsKey(java.lang.String key)

  Returns `true` if and only if this `CompositeData` instance contains an item whose name is `key`. If `key` is a null or empty String, this method simply returns false.

  Specified by:
    `containsKey` in interface `CompositeData`
  Parameters:
    `key` - the key to be tested.
  Returns:
    true if this `CompositeData` contains the key.

### containsValue

    public boolean containsValue(java.lang.Object value)

  Returns `true` if and only if this `CompositeData` instance contains an item whose value is `value`.

  Specified by:
    `containsValue` in interface `CompositeData`
  Parameters:
    `value` - the value to be tested.
  Returns:
    true if this `CompositeData` contains the value.

### values

    public java.util.Collection values()

  Returns an unmodifiable Collection view of the item values contained in this `CompositeData` instance. The returned collection's iterator will return the values in the ascending lexicographic order of the corresponding item names.

  Specified by:
    `values` in interface `CompositeData`
  Returns:
    the values.

### equals

    public boolean equals(java.lang.Object obj)

  Compares the specified obj parameter with this `CompositeDataSupport` instance for equality.

  Returns `true` if and only if all of the following statements are true:

  - obj is non null,
  - obj also implements the `CompositeData` interface,
  - their composite types are equal
  - their contents, i.e. (name, value) pairs are equal.
  This ensures that this `equals` method works properly for obj parameters which are different implementations of the `CompositeData` interface, with the restrictions mentioned in the `equals` method of the `java.util.Collection` interface.

  Specified by:
    `equals` in interface `CompositeData`
  Parameters:
    `obj` - the object to be compared for equality with this `CompositeDataSupport` instance;
  Returns:
    `true` if the specified object is equal to this `CompositeDataSupport` instance.

### hashCode

    public int hashCode()

  Returns the hash code value for this `CompositeDataSupport` instance.

  The hash code of a `CompositeDataSupport` instance is the sum of the hash codes of all elements of information used in `equals` comparisons (ie: its composite type and all the item values).

  This ensures that `t1.equals(t2)` implies that `t1.hashCode()==t2.hashCode()` for any two `CompositeDataSupport` instances `t1` and `t2`, as required by the general contract of the method `Object.hashCode()`.

  However, note that another instance of a class implementing the `CompositeData` interface may be equal to this `CompositeDataSupport` instance as defined by `equals(java.lang.Object)`, but may have a different hash code if it is calculated differently.

  Specified by:
    `hashCode` in interface `CompositeData`
  Returns:
    the hash code value for this `CompositeDataSupport` instance

### toString

    public java.lang.String toString()

  Returns a string representation of this `CompositeDataSupport` instance.

  The string representation consists of the name of this class (ie `javax.management.openmbean.CompositeDataSupport`), the string representation of the composite type of this instance, and the string representation of the contents (ie list the itemName=itemValue mappings).

  Specified by:
    `toString` in interface `CompositeData`
  Returns:
    a string representation of this `CompositeDataSupport` instance

Overview | Package | Class | Tree | Deprecated | Index | Help
| J2EE1.4 SDK
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature

Copyright 2003 Sun Microsystems, Inc. All rights reserved.